$INCLUDE"ISO1.INC"
'------------------- Programm ISO - Version 28/10/1988  ---------------------
'                                Autor: Dirk Brehm
'
      DEFINT I-K, M
      DEFLNG L, N
      DEFDBL D, P, T, V, X-Z
      DEFSNG U
      IFDim = 1
      OPTION BASE 0
      DIM STATIC IZeich(1:2000), IAtt(1:2000) ' nur eine Seite
      DIM STATIC IDTA(1 : 22), IMask(1 : 12), FileN$(112)
      DIM STATIC Typ$(1 : 22), Pmod$(1), IPlen(22), IRow(22), ICol(22)
      DIM STATIC H$(5), ILoc(5)
      DIM STATIC UZ(16000), Dx(100), Dy(100), T(100), C$(100), B$(100), HT$(100)
      DIM STATIC IAsci(1:95), IAnf(1:95), Ile(1:95), Ilf(1:95), IVec(1:4200)
      DIM STATIC IKey(256)
      ITDim = 100
      IZDim = 16000
      Pi = ATN(1!) * 4!
      PiD180 = Pi / 180!
      ON ERROR GOTO FEHLERMELDUNG
      CALL HARDWARE
      CALL SETTEXT
      CALL SETCFGPOS
      CALL SETHELPTEXT
      CALL READFONT
      CALL SETKEY
      CALL SCRNTYPE
'----------------------- globale Programmparameter ---------------------------
      NPau = 20
      Logo$ = " Isolinienplots "
      R$ = "    JA"
      Proto$ = "  NEIN"
      PltFil$ = "  HPGL"
      NSatz = 1
      IPlot = 1
      ILabel = 0
      IFop = 0
      HeadTxt$ = ""
      FootTxt$ = ""
      NXTick = 10
      NYTick = 10
      NsXTick = 4
      NsYTick = 4
      Iop = 10
      Iup = 5

LOGOLIN:

      Upro$ = "MAIN"
      SCREEN 0, 0, 0: CLS
      CALL RAHMEN(1, 80, 1, 3, 1, 0)
      LOCATE 1, 33
      PRINT Logo$
      IPos = 1

HP10:
      CALL HAUPTMENU(IPos)

HP20:

      CALL PRESSKEY(FLAG$)
      CALL SCAN(FLAG$, Isc1, Isc2, Isc)
      SELECT CASE Isc
        CASE 13
        CASE 1031
          CALL SPEICHERFREI
          GOTO HP10
        CASE 9, 32, 1077
          CALL POSITION(IPos, 5, 1, 1)
          GOTO HP10
        CASE 8, 1015, 1075
          CALL POSITION(IPos, 5, 1, -1)
          GOTO HP10
        CASE 68
          IPos = 1
        CASE 80
          IPos = 2
        CASE 73
          IPos = 3
        CASE 72, 1059
          IPos = 4
        CASE 69, 27
          IPos = 5
        CASE ELSE
          GOTO HP20
      END SELECT
      CALL HAUPTMENU(IPos)
      IF IPos = 3 AND MaxSatz = 0 THEN
         Text$ = "Ich habe noch keine Daten fr Isolinienplots"
         CALL TEXTBOX(15, 15, 0, Text$, A$)
         GOTO HP20
      END IF

      ON ERROR GOTO FEHLERMELDUNG
      ON IPos GOSUB DATEN, PARAMETER, CONTOUR, HILFE, ENDE
      LOCATE 1, 1, 0, 0, 0

      IF IPos = 3 THEN LOGOLIN
      GOTO HP20

ENDE:
      COLOR 7, 8
      Text$ = " ISO verlassen?  (J/N) "
      CALL TEXTBOX(13, 30, 0, Text$, Ret$)
      IF Ret$ = "J" OR Ret$ = CHR$(13) THEN
         CLS
         SCREEN 0, 0, 0, 0
         END
      ELSE
         RETURN
      END IF


HILFE:
      CALL HILFISO
      RETURN

DATEN:

      CALL RAHMEN(24, 58, 20, 22, 1, 0)
      IF IFop = 1 THEN
         LOCATE 21, 26: PRINT "Ich lade weitere Daten ...    ";
         CALL WARTE(1, "")
         GOTO DAT30
      END IF
      LOCATE 21, 26: PRINT "Ich lese das Directory ...    ";
      Pfad$ = "*.*"
      DirTxt$ = "Whlen Sie eine Datei!"
      CALL DIRECTORY(File$, Pfad$, IDir, 1)
      IF File$ = "" THEN
         CALL LOESCHEN(1, 80, 5, 24)
         RETURN
      END IF
      OPEN File$ FOR BINARY AS #1
      GET$ 1, 6, Binaer$
      IBin = 0
      IF Binaer$ = "BINARY" THEN IBin = 1
      IF IBin = 0 THEN
         CLOSE #1
         OPEN File$ FOR INPUT AS #1
      END IF
      Nx1 = 1
      Ny1 = 1
      Nx = 0
      Ny = 0
      MaxSatz = 0
      IF IBin = 1 THEN
         GET$ 1, 4, Z$
         Nx = CVL(Z$)
         GET$ 1, 4, Z$
         Ny = CVL(Z$)
      ELSE
         INPUT #1, Nx
         INPUT #1, Ny
      END IF
      MaxSatz = INT(IZDim / Nx / Ny) - 1
      IF MaxSatz > ITDim THEN MaxSatz = ITDim
      XMin = 0
      YMin = 0
      XMax = 0
      YMax = 0
      Icp = 0
      Icm = 0
      DXplus = 0
      DYplus = 0

      IF IBin = 1 THEN
         Z$ = ""
         GET$ 1, 4 * (Nx - 1), Z$
         J = 1
         FOR I = 1 TO Nx - 1
             Dx(I) = CVS(MID$(Z$, J, 4))
             INCR J, 4
             XMax = XMax + Dx(I)
         NEXT I
         Z$ = ""
         GET$ 1, 4 * (Ny - 1), Z$
         I = 1
         FOR J = Ny - 1 TO 1 STEP -1
             Dy(J) = CVS(MID$(Z$, I, 4))
             INCR I, 4
             YMax = YMax + Dy(J)
         NEXT J
      ELSE
         FOR I = 1 TO Nx - 1
             INPUT #1, Dx(I)
             XMax = XMax + Dx(I)
         NEXT I
         CALL READNONZERO(Dy(Ny - 1))
         YMax = Dy(Ny - 1)
         FOR J = Ny - 2 TO 1 STEP -1
             INPUT #1, Dy(J)
             YMax = YMax + Dy(J)
         NEXT J
      END IF

      Xmn = XMin
      Xmx = XMax
      Ymn = YMin
      Ymx = YMax
 
DAT30:
     FOR NSatz = 1 TO MaxSatz
         M =  (NSatz - 1) * Nx * Ny
         LOCATE 21, 26: PRINT "Ich lese Datensatz Nr. "; NSatz; "...";
         IF IBin = 1 THEN
            GET$ 1, 4, Z$
            IF LEN(Z$) <> 4 THEN DAT10
            T(NSatz) = CVS(Z$) / 86400
            CALL BINREC(M, IEOF)
            IF IEOF = 1 THEN DAT10
         ELSE
            IF EOF(1) THEN DAT10
            CALL READNONZERO(T(NSatz))
            T(NSatz) = T(NSatz) / 86400
            FOR J = Ny TO 1 STEP -1
                K = (J - 1) * Nx + 1 + M
                CALL READNONZERO(XWert)
                UZ(K) = XWert
                FOR I = 2 TO Nx
                    K = (J - 1) * Nx + I + M
                    IF EOF(1) THEN DAT10
                    INPUT #1, UZ(K)
                NEXT I
            NEXT J
         END IF
     NEXT NSatz
     IFop = 1
     GOTO DAT20

DAT10:
     MaxSatz = NSatz - 1
     CLOSE #1
     IFop = 0

DAT20:
     NSatz = 1
     LOCATE 21, 26: PRINT "Ich suche die Extremwerte ... ";
     ZMin = 1E+30
     ZMax = -1E+30
     FOR K = 1 TO Nx * Ny * MaxSatz
         Luz = UZ(K)
         IF Luz <> 999 THEN
            IF ZMin > UZ(K) THEN ZMin = UZ(K)
            IF ZMax < UZ(K) THEN ZMax = UZ(K)
         END IF
     NEXT K
     ZMax0 = ZMax
     ZMin0 = ZMin
     Zmx = ZMax
     Zmn = ZMin
     Zc = ABS(ZMax - ZMin) / 10!
     Nxx = Nx
     Nyy = Ny
     CALL LOESCHEN(24, 60, 20, 22)
     RETURN

PARAMETER:

     CALL CONFIG

     DXplus = 0
     DYplus = 0

     IF ILabel = 0 THEN
        Xmn = 0
        FOR I = 1 TO Nx1 - 1
            Xmn = Xmn + Dx(I)
        NEXT I
        Ymn = 0
        FOR J = 1 TO Ny1 - 1
            Ymn = Ymn + Dy(J)
        NEXT J
        Xmx = Xmn
        FOR I = Nx1 TO Nxx - 1
            Xmx = Xmx + Dx(I)
        NEXT I
        Ymx = Ymn
        FOR J = Ny1 TO Nyy - 1
            Ymx = Ymx + Dy(J)
        NEXT J
        GOTO PAR10:
     END IF

     CALL OPTIMIZE

PAR10:

     ZMinCfg = ZMin
     ZMaxCfg = ZMax

     RETURN

CONTOUR:

     CALL SCALA
     CALL FENSTER
     IPlotOn = 0
     IF RIGHT$(Proto$, 1) = "A" THEN IPlotOn = 1
     IF IPlotOn = 1 THEN
        CLOSE
        CALL LINKS(PltFil$)
        CALL PLOTINI
     END IF
     CALL ZTRUNC
     CALL RASTER

PLOTACHSEN:
     IF ILabel = 1 THEN
        CALL ACHSEN(NXTick, NYTick, NsXTick, NsYTick)
        CALL TEXTATT(1, 0, 10, 1)
        CALL LINKS(HeadTxt$)
        CALL PLTTXT(HeadTxt$, Xmn + Xsp / 35, Ymx + Ysp / 30, .6)
        CALL LINKS(FootTxt$)
        CALL AXLABEL(T#(NSatz), Tag$, 2, 2)
        CALL PLTTXT(FootTxt$, Xmn + Xsp / 35, Ymns + Ysp / 40, .4)
        ZEIT$ = "Situation nach " + Tag$ + " Tagen"
        CALL PLTTXT(ZEIT$, Xmn + Xsp / 1.3, Ymns + Ysp / 40, .4)
        CALL PLTTXT("db 88", Xmx + Xsp / 50, Ymn - Ysp / 30, .25)
     END IF

BEGINPLOT:

     Upro$ = "CONTOUR"
     IF ILabel = 0 THEN
        LOCATE 23, 1
        PRINT USING "min  = ####.##   max  = ####.##"; Zmn + Icp * Zc; Zmx + Icm * Zc;
        PRINT USING "  T  = ####.##"; T(NSatz);
        PRINT " Tage  <F2> ==> Zoom  <ESC> ==> Ende";
     END IF

     FOR Zh = Zmn + Zc * Icp TO Zmx + Zc * Icm STEP Zc
         IF ILabel = 0 THEN
            LOCATE 24, 1: PRINT USING "Isolinienniveau = ####.##"; Zh;
            PRINT USING "  Datensatz = ###"; NSatz;
            PRINT "      Plotter - Protokoll:" + Proto$; "     ";
         END IF
         IF IPlotOn = 1 THEN PRINT #2, " SP3;"
         DySum = Ymn - Dy(Ny1 - 1) + DYplus
         FOR J = Ny1 - 1 TO Nyy - 2
             DxSum = Xmn - Dx(Nx1 - 1) + DXplus
             DySum = DySum + Dy(J)
             FOR I = Nx1 - 1 TO Nxx - 2
                 Taste$ = INKEY$
                 IF Taste$ <> "" THEN CT100
                 YDy = (Ymx - Ymn) / Dy(J + 1)
                 XDx = (Xmx - Xmn) / Dx(I + 1)
                 IF ILabel = 0 THEN ZsY = 4 * (Y2S - Y1S) / (XDx + YDy)
                 IF ILabel = 1 THEN ZsY = 4 * (Y2C - Y1C) / (XDx + YDy)
                 Zde = 1 / ZsY
                 IJ = J * Nx + (NSatz - 1) * Nx * Ny
                 II1 = I + 1 + IJ
                 II2 = I + 2 + IJ
                 II3 = I + 2 + IJ + Nx
                 II4 = I + 1 + IJ + Nx
                 Z1 = UZ(II1)
                 Z2 = UZ(II2)
                 Z3 = UZ(II3)
                 Z4 = UZ(II4)
                 DxSum = DxSum + Dx(I)
                 IF Z1 > Zh AND Z2 > Zh AND Z3 > Zh AND Z4 > Zh THEN CT80
                 IF Z1 < Zh AND Z2 < Zh AND Z3 < Zh AND Z4 < Zh THEN CT80
                 IF Z1 = Zh AND Z2 = Zh AND Z3 = Zh AND Z4 = Zh THEN CT80
                 Zk2 = Z1 - Z2
                 Zk1 = Zk2 + Z3 - Z4
                 Zk3 = Z1 - Z4
                 Zk4 = Zh - Z1
                 Yr = DySum
                 Xr = DxSum
                 IF (Zk1 * Zk4 + Zk2 * Zk3) <> 0 THEN CT40
                 IF Zk1 > 0 AND Zk2 > 0 THEN CT20
                 IF Zk1 <> 0 THEN Zzz = Zk3 / Zk1: GOTO CT10
                 IF Zk2 <> 0 THEN Zzz = -Zk4 / Zk2
CT10:
                 Xl = Xr + Dx(I + 1) * Zzz
                 IF Xl < Xr OR Xl > Xr + Dx(I + 1) THEN CT20
                 X = Xl
                 Y = Yr
                 CALL PUNKT(X, Y)
                 X = Xl
                 Y = Yr + Dy(J + 1)
                 CALL LINIE(X, Y)
CT20:
                 IF Zk1 = 0 AND Zk3 = 0 THEN CT40
                 IF Zk1 <> 0 THEN Zzz = Zk2 / Zk1: GOTO CT30
                 Zzz = -Zk4 / Zk3
CT30:
                 Yp = Yr + Dy(J + 1) * Zzz
                 IF Yp > Yr + Dy(J + 1) OR Yp < Yr THEN CT40
                 X = Xr
                 Y = Yp
                 CALL PUNKT(X, Y)
                 X = Xr + Dx(I + 1)
                 Y = Yp
                 CALL LINIE(X, Y)
CT40:
                 Xa = 1
                 Xe = 0
                 IFl = 0
                 FOR Zzz = 0 TO 1 STEP Zde
                     Ze = Zzz * Zk1 - Zk2
                     Za = Zzz * Zk3 + Zk4
                     IF Ze = 0 THEN CT50
                     Xi = Za / Ze
                     IF Xi > 1 OR Xi < 0 THEN IFl = 0: GOTO CT50
                     X = Xr + Dx(I + 1) * Xi
                     Y = Yr + Dy(J + 1) * Zzz
                     IF X < Xmn OR Y < Ymn THEN CT50
                     IF IFl = 0 THEN
                        CALL PUNKT(X, Y)
                        IFl = 1
                     END IF
                     CALL LINIE(X, Y)
                     IF Xe < Xi THEN Xe = Xi
                     IF Xa > Xi THEN Xa = Xi
CT50:
                 NEXT Zzz
                 Xa = Zde
                 IFl = 0
                 FOR Zzz = 0 TO Xa STEP Zde / 3!
                     Ze = Zzz * Zk1 - Zk3
                     IF Ze = 0 THEN CT60
                     Za = Zzz * Zk2 + Zk4
                     Yi = Za / Ze
                     IF Yi > 1 OR Yi < 0 THEN CT60
                     X = Xr + Dx(I + 1) * Zzz
                     Y = Yr + Dy(J + 1) * Yi

                     IF IFl = 0 THEN
                        CALL PUNKT(X, Y)
                        IFl = 1
                     END IF
                     CALL LINIE(X, Y)
CT60:
                 NEXT Zzz
                 IFl = 0
                 FOR Zzz = Xe TO 1 STEP Zde / 3!
                     Ze = Zzz * Zk1 - Zk3
                     IF Ze = 0 THEN CT70
                     Za = Zzz * Zk2 + Zk4
                     Yi = Za / Ze
                     IF Yi > 1 OR Yi < 0 THEN IFl = 0: GOTO CT70
                     X = Xr + Dx(I + 1) * Zzz
                     Y = Yr + Dy(J + 1) * Yi
                     IF IFl = 0 THEN
                        CALL PUNKT(X, Y)
                        IFl = 1
                     END IF
                     CALL LINIE(X, Y)
CT70:
               NEXT Zzz
CT80:
             NEXT I
         NEXT J
     NEXT Zh

CT100:

     ZMin = ZMinCfg
     ZMax = ZMaxCfg
     IF ILabel = 0 THEN
        LOCATE 24, 1
        PRINT USING "Differenz = ##.## xmin = ####.## xmax = ####.##"; Zc; Xmn; Xmx;
        PRINT USING " ymin = ####.##  ymax = ####.##"; Ymn; Ymx;
     END IF
     IF IPlotOn = 1 THEN CALL PLOTTEROFF
     CALL WARTE(CINT(NPau), Taste$)
     IF Taste$ = "" THEN Taste$ = CHR$(32)

CT120:
     CALL SCAN(Taste$, Isc1, Isc2, Isc3)
     IF Isc3 = 27 THEN RETURN
     IF Isc3 = 1060 THEN
        IF ILabel = 0 THEN CALL LOESCHEN(1, 80, 23, 24)
        CALL ZOOM
        CALL SCALA
        CALL FENSTER
        IF IPlotOn = 1 THEN CALL PLOTINI
        CALL RASTER
        CALL OPTIMIZE
        CALL ZTRUNC
        IF ILabel = 1 THEN PLOTACHSEN
        Upro$ = "CONTOUR"
        GOTO BEGINPLOT
     END IF
     INCR NSatz
     IF NSatz > MaxSatz THEN
        NSatz = 1
        IPlotOn = 0
     END IF
     CALL ZTRUNC
     CLS
     IF IPlotOn = 1 THEN CALL PLOTINI
     CALL RASTER
     GOTO PLOTACHSEN


FEHLERMELDUNG:

     CALL FEHLER

DATA "Daten lesen","Plotparameter","Isolinien","Hilfe","Ende"
DATA  4, 22, 43, 59, 70
DATA "Anfangsknoten X","Endknoten X","Anfangsknoten Y"
DATA "Endknoten Y","Raster","HP-GL Protokoll"
DATA "Minimalwert","Maximalwert","Isolinienabstand"
DATA "Datensatz","Pause in Sekunden","Protokoll - File"
DATA "X - Minimum","X - Maximum","Y - Minimum","Y - Maximum"
DATA "berschrift","Unterschrift","X - Beschriftungen"
DATA "X - Unterteilungen","Y - Beschriftungen","Y - Unterteilungen"
DATA 218, 191, 217, 192, 179, 196    ' Rahmen Variante 1
DATA 201, 187, 188, 200, 186, 205    ' Rahmen Variante 2

DATA   7,  9, 11, 13, 15, 17,  7,  9, 11, 13, 15, 17  'Positionen im CFG-Menue
DATA   7,  9, 11, 13, 15, 17,  7,  9, 11, 13
DATA  23, 23, 23, 23, 23, 23, 70, 70, 70, 70, 70, 70
DATA  23, 23, 23, 23, 23, 23, 70, 70, 70, 70

SUB ACHSEN (NXTick, NYTick, NsXTick, NsYTick)
SHARED Xmn, Xmx, Ymn, Ymx, Xsp, Ysp, IPlotOn
SHARED Upro$
LOCAL I, J

      Upro$ = "ACHSEN"
      XTickin = Xsp / NXTick
      YTickin = Ysp / NYTick

      YeTick = Ymn - Ysp / 50
      YseTick = Ymn - Ysp / 100
      XAxlDis = Ymn - Ysp / 15

      XeTick = Xmx + Xsp / 50
      XseTick = Xmx + Xsp / 100
      YAxlDis = Xmx + Xsp / 20

      CALL RECHTECK(Xmn, Ymn, Xmx, Ymx)

      CALL TEXTATT(1, -30, 0, 1)

      FOR I = 0 TO NXTick
          XTick = Xmn + I * XTickin

          CALL PUNKT(XTick, Ymn)
          CALL LINIE(XTick, YeTick)

          IF NsXTick > 0 AND I < NXTick THEN
             XsTick = 0
             FOR Ixs = 1 TO NsXTick
                 XsTick = XTick + Ixs * XTickin / (NsXTick + 1)
                 CALL PUNKT(XsTick, Ymn)
                 CALL LINIE(XsTick, YseTick)
              NEXT Ixs
           END IF

          CALL AXLABEL(XTick, Text$, 4, 2)
          CALL PLTTXT(Text$, XTick, XAxlDis, .3)

      NEXT I

      CALL TEXTATT(1, 0, 0, 1)

      FOR J = 0 TO NYTick
          YTick = Ymn + J * YTickin

          CALL PUNKT(Xmx, YTick)
          CALL LINIE(XeTick, YTick)

          IF NsYTick > 0 AND J < NYTick THEN
             YsTick = 0
             FOR Jys = 1 TO NsYTick
                 YsTick = YTick + Jys * YTickin / (NsYTick + 1)
                 CALL PUNKT(Xmx, YsTick)
                 CALL LINIE(XseTick, YsTick)
              NEXT Jys
           END IF

          CALL AXLABEL(YTick, Text$, 4, 2)
          CALL PLTTXT(Text$, YAxlDis, YTick, .3)
      NEXT J

END SUB

SUB AXLABEL (Zzzz, Zahl$, IVk, INk)
LOCAL LZahl, I
      ZZ = ABS(Zzzz) + .000005
      LZahl = FIX(ZZ)

      IF LZahl > 0 THEN

         Zahl$ = MID$(STR$(LZahl), 2, IVk)
         IF Zzzz < 0 THEN Zahl$ = "-" + Zahl$
         Zahl$ = SPACE$(IVk - LEN(Zahl$)) + Zahl$
         IF INk < 0 THEN AXL10
         IF INk = 0 THEN Zahl$ = Zahl$ + ".": GOTO AXL10
         Zahl$ = Zahl$ + "."

      END IF

      IF LZahl = 0 THEN

         Zahl$ = ""
         IF Zzzz < 0 THEN Zahl$ = "-"
         Zahl$ = Zahl$ + "0"
         Zahl$ = SPACE$(IVk - LEN(Zahl$)) + Zahl$
         IF INk >= 0 THEN Zahl$ = Zahl$ + "."
         IF INk = 0 THEN AXL10

      END IF

      NKZ$ = ""
      FOR I = 1 TO INk + 1
          Z = INT((ZZ - LZahl) * 10 ^ I)
          NKZ$ = NKZ$ + RIGHT$(STR$(Z), 1)
      NEXT I

AXL20:
      Zahl$ = Zahl$ + MID$(NKZ$, 1, INk)

AXL10:

END SUB

SUB BINREC(M, IEOF)
SHARED UZ(), Nx, Ny, Upro$
LOCAL Z$, I, J, NxyByte

         Upro$ = "BINREC"
         NxyByte =  4 * Nx * Ny
         Z$ = ""
         GET$ 1, NxyByte, Z$
         IF LEN(Z$) < NxyByte THEN
            IEOF = 1
            Z$ = ""
            EXIT SUB
         END IF
         IEOF = 0
         FOR J = 1 TO Ny
             KK = (J - 1) * Nx
             Kb = (Ny - J) * Nx * 4 + 1
             FOR I = 1 TO Nx
                 INCR KK
                 UZ(KK + M) = CVS(MID$(Z$, Kb, 4))
                 INCR Kb, 4
             NEXT I
         NEXT J

END SUB

SUB CHECK (ICHE)
SHARED ZMin, ZMax, Zmn, Zmx, ZMin0, ZMax0
SHARED Zc, Nx, Ny, Nx1, Ny1, Nxx, Nyy, NPau, R$, MaxSatz, NSatz
SHARED XMin, XMax, YMin, YMax, Xmn, Xmx, Ymn, Ymx
SHARED NXTick, NYTick, NsXTick, NsYTick
SHARED Upro$

     Upro$ = "CHECK"
     IF ICHE = 1 THEN CHE20
     ICheck = 0
     IF NSatz > MaxSatz THEN NSatz = MaxSatz
     IF NSatz < 1 THEN NSatz = 1
     Zc = ABS(Zc)

CHE10:
     IF Zc > ABS(Zmn - Zmx) / 2 OR Zc = 0 THEN Zc = ABS(Zmn - Zmx) / 10
     IF ZMin < ZMin0 OR ZMin > ZMax - 2! * Zc THEN ZMin = ZMin0
     IF ZMax > ZMax0 OR ZMax < ZMin + 2! * Zc THEN ZMax = ZMax0
     Zmn = ZMin
     Zmx = ZMax
     IF Nxx > Nx OR Nxx < Nx1 + 2 OR Nxx < 0 THEN Nxx = Nx
     IF Nyy > Ny OR Nyy < Ny1 + 2 OR Nyy < 0 THEN Nyy = Ny
     IF Nx1 > Nxx - 2 OR Nx1 < 1 THEN Nx1 = 1
     IF Ny1 > Nyy - 2 OR Ny1 < 1 THEN Ny1 = 1
     INCR ICheck
     IF ICheck = 1 THEN CHE10
     IF ICHE = 0 THEN CHE30

CHE20:
     IF Xmn < XMin OR Xmn > Xmx THEN Xmn = XMin
     IF Ymn < YMin OR Ymn > Ymx THEN Ymn = YMin
     IF Xmx > XMax OR Xmx <= Xmn THEN Xmx = XMax
     IF Ymx > YMax OR Ymx <= Ymn THEN Ymx = YMax
     IF NXTick > 30 OR NXTick < 2 THEN NXTick = 10
     IF NYTick > 30 OR NYTick < 2 THEN NYTick = 10
     IF NsXTick > 10 OR NsXTick < 0 THEN NsXTick = 4
     IF NsYTick > 10 OR NsYTick < 0 THEN NsYTick = 4

CHE30:

END SUB

SUB CONFIG
SHARED ISA, ILabel, ICuSize, Insert
SHARED R$, B$(), C$(), PltFil$, Proto$
SHARED Typ$(), Pmod$(), IPlen(), ISP(), IFT(), IZE(), IRow(), ICol()
SHARED Upro$

      CALL SET(2)
      Upro$ = "CONFIG"
      CALL RAHMEN(1, 80, 5, 19, 1, 1)
      LOCATE 19, 30: PRINT " Verlassen mit <ESC> "
      Mess$ = "Default - Werte durch Eingabe von <F1>"
      LOCATE 22, 20
      PRINT Mess$;
      CALL RAHMEN(1, 80, 21, 23, 1, 0)
      CALL EDITSCREEN(0, " ", 1082, " ", 0)

CON10:
      CALL LOESCHEN(2, 79, 6, 18)
      COLOR 7, 8
      LOCATE 5, 25
      PRINT " Plotparametermenue"; ILabel + 1; "von 2 ";
      LOCATE 5, 63
      COLOR 10, 8
      PRINT " ";Pmod$(ILabel);
      COLOR 7, 8

      II = ILabel * 12
      FOR J = 1 TO 2
          FOR I = 1 TO 6
              INCR II
              LOCATE IZE(I), ISP(J), 0, 0, 0
              PRINT B$(II);
              IF II > 22 THEN CON40
          NEXT I
      NEXT J


CON40:

      II = ILabel * 12
      IPos = II + 1
      IPosAlt = IPos
      COLOR 7, 8
      FOR I = II + 1 TO IFT(ILabel) + II
          LOCATE IRow(I), ICol(I), 0, 0, 0
          IF Typ$(I) = "N" THEN CALL RECHTS(C$(I), IPlen(I))
          PRINT C$(I);
      NEXT I

CON45:
      IRa = IRow(IPosAlt)
      ICa = ICol(IPosAlt)
      CALL CHNGATT(ICa, ICa + IPlen(IPosAlt) - 1, IRa, IRa, 7)
      IRn = IRow(IPos)
      ICn = ICol(IPos)
      CALL CHNGATT(ICn, ICn + IPlen(IPos) - 1, IRn, IRn, 120)
      IPosAlt = IPos
      LOCATE IRn, ICn, 1, ICuSize - (Insert * 3), ICuSize

CON30:
      CFG$ = INKEY$
      IF CFG$ = "" THEN CON30
      CALL SCAN(CFG$, Isc1, Isc2, Isc3)

CON35:

      IP1 = ILabel * IFT(ILabel - 1) + 1
      IP2 = IP1 - 1 + IFT(ILabel)
      IPL = IPlen(IPos)
      SELECT CASE Isc3
        CASE 1073, 1081
          ILabel = ABS(ILabel - 1)
          GOTO CON10
        CASE 1059
          CALL DEFAULT(ILabel)
          CALL SET(ILabel)
          GOTO CON40
        CASE 1071
          IPos = IP1
        CASE 1079
          IPos = IP2
        CASE 13, 32, 1080
          CALL POSITION(IPos, IP2, IP1, 1)
        CASE 1072
          CALL POSITION(IPos, IP2, IP1, -1)
        CASE 9, 1116, 1115
          I = IPos
          SELECT CASE I
             CASE 1 TO 6, 13 TO 18
              IPos = I + 6
            CASE ELSE
              IPos = I - 6
            END SELECT
            IF IPos > 22 THEN IPos = 22
        CASE 27
          CALL LOESCHEN(1, 80, 5, 23)
          CALL RRSET(2)
          EXIT SUB
        CASE 32 TO 110, 1083, 1075, 1077, 1082
          GOTO CON36
        CASE ELSE
          GOTO CON30
      END SELECT
      GOTO CON45

CON36:
      IF IPos = 5 OR IPos = 6 THEN
         IF RIGHT$(C$(IPos), 1) = "N" THEN
            C$(IPos) = "JA"
         ELSE
            C$(IPos) = "NEIN"
         END IF
         COLOR 8, 7
         LOCATE IRn, ICn, 0, 0, 0
         CALL RECHTS(C$(IPos), IPL)
         PRINT C$(IPos);
         COLOR 7, 8
         GOTO CON30
      END IF
      Z$ = C$(IPos)
      CALL READFELD(IRn, ICn, IPL, D, Z$, Typ$(IPos), Isc3)
      C$(IPos) = Z$
      CALL RRSET(ILabel)
      CALL CHECK(ILabel)
      CALL SET(ILabel)
      LOCATE IRn, ICn, 0, 0, 0
      PRINT C$(IPos);
      GOTO CON35

END SUB

SUB DEFAULT (IDEF)
SHARED ZMin, ZMax, Zmn, Zmx, ZMin0, ZMax0
SHARED Zc, Nx, Ny, Nx1, Ny1, Nxx, Nyy, NPau, NSatz, R$, Proto$, PltFil$, T()
SHARED XMin, XMax, YMin, YMax, Xmn, Xmx, Ymn, Ymx
SHARED NXTick, NYTick, NsXTick, NsYTick, HeadTxt$, FootTxt$
SHARED Upro$
      Upro$ = "DEFAULT"
      IF IDEF = 1 THEN DEF10
      Zmn = ZMin0
      Zmx = ZMax0
      Nx1 = 1
      Ny1 = 1
      Nxx = Nx
      Nyy = Ny
      NPau = 20
      NSatz = 1
      R$ = "    JA"
      Proto$ = "  NEIN"
      PltFil$ = "  HPGL"
      Zc = ABS(ZMax0 - ZMin0) / 10!
      IF IDEF = 0 THEN DEF20
DEF10:
      Xmn = XMin
      Ymn = YMin
      Xmx = XMax
      Ymx = YMax
      NXTick = 10
      NsXTick = 4
      NYTick = 10
      NsYTick = 4
      HeadTxt$ = "Erdsondenforschungsanlage Schwalbach"
      CALL AXLABEL(Zc, ABST$, 2, 2)
      FootTxt$ = "Isothermenabstand  = " + ABST$ + " Grad"

DEF20:

END SUB

SUB FEHLER
SHARED Upro$, IPos
     IF IPos = 3 THEN SCREEN 0, 0, 0: CLS
     IF IPos <> 3 THEN CALL LOESCHEN(1, 80, 5, 24)
     CALL RAHMEN(1, 80, 22, 24, 1, 1)
     SELECT CASE ERR
        CASE 5
             FTXT$ = "ungltiger Funktionsaufruf in Routine " + Upro$
        CASE 7
             FTXT$ = "Hauptspeicher zu klein"
        CASE 9
             FTXT$ = "ungltiger Feldindex in Routine " + Upro$
        CASE 11
             FTXT$ = "Division durch Null in Routine " + Upro$
        CASE 15
             FTXT$ = "Zeichenkette zu lang in Routine " + Upro$
        CASE 53
             FTXT$ = "Datei nicht gefunden in Routine " + Upro$
        CASE 54
             FTXT$ = "falscher Dateityp in Routine " + Upro$
        CASE 61
             FTXT$ = "kein Platz auf Datentrger"
        CASE 62
             FTXT$ = " unerwartet Ende der Datei erreicht"
        CASE 64
             FTXT$ = "falscher Dateiname in Routine " + Upro$
        CASE 67
             FTXT$ = "zu viele Dateien im aktuellen Directory"
     CASE ELSE
             FTXT$ = "Fehler " + STR$(ERR) + " in Routine " + Upro$
     END SELECT
     CLOSE
     LOCATE 23, 20: PRINT FTXT$;
     CALL WARTE(5, "")
     CALL LOESCHEN(1, 80, 5, 24)
     IF ERR = 62 OR ERR = 64 OR ERR = 11 THEN RESUME DATEN
     IF IPos = 3 THEN RESUME LOGOLIN
     RESUME HP20

END SUB

SUB FENSTER
SHARED X1C, Y1C, X2C, Y2C, Xmns, Ymns, Xmxs, Ymxs, ILabel
SHARED X1S, Y1S, X2S, Y2S, IScrn
SHARED Upro$

     Upro$ = "FENSTER"
     SCREEN IScrn
     IF ILabel = 0 THEN VIEW (X1S, Y1S)-(X2S, Y2S)
     IF ILabel = 1 THEN VIEW (X1C, Y1C)-(X2C, Y2C)
     WINDOW (Xmns, Ymns)-(Xmxs, Ymxs)

END SUB

SUB HARDWARE
SHARED X1H, Y1H, X2H, Y2H, X1C, Y1C, X2C, Y2C, ADB, BDA, IScrn
SHARED P1X, P1Y, P2X, P2Y
SHARED Upro$

     Upro$ = "HARDWARE"
     X1C = 0
     Y1C = 0
     X1H = 0
     Y1H = 0
     IScrn = 2
     DEF SEG = &H40
     ICARD = PEEK(&H49)
     IF ICARD = 7 THEN ' ---> Hercules Karte
        X2C = 719
        Y2C = 347
        X2H = 719
        Y2H = 300
        AA = 14
        BB =  9
        GOTO HAR10
     END IF
     ON ERROR GOTO HW2
     SCREEN 9
     IScrn = 9
     X2C = 639
     Y2C = 349
     X2H = 639
     Y2H = 300
     AA = 12
     BB =  9
     GOTO HAR10

HW2:
     RESUME HW2A

HW2A:

     X2C = 639
     Y2C = 199
     X2H = 639
     Y2H = 170
     AA = 12
     BB =  5

HAR10:

     ON ERROR GOTO FEHLERMELDUNG
     SCREEN 0, 0, 0, 0

     ADB = AA / BB
     BDA = BB / AA

     P1X = 170
     P1Y = 602
     P2X = 15370
     P2Y = 10602

END SUB

SUB HAUPTMENU (IPos)
SHARED Upro$, H$(), ILOC()

      Upro$ = "HAUPTMENU"
      FOR J = 1 TO 5
          IX = 7
          JY = 8
          IC = 1
          IF IPos = J THEN IX = 8: JY = 7: IC = 0
          LOCATE 2, ILOC(J), 0, 0, 0
          COLOR 10, 8: PRINT LEFT$(H$(J), 1);
          COLOR IX, JY
          LOCATE 2, ILOC(J) + IC
          PRINT MID$(H$(J), IC + 1);
      NEXT J
END SUB

SUB HILFISO
SHARED HT$()
    CALL RAHMEN(1, 80, 5, 24, 1, 0)
    J = 1
    LOCATE 5, 37: PRINT " Hilfe ";

HIL10:
    CALL LOESCHEN(2, 79, 6, 23)
    LOCATE 24, 37: PRINT USING " # von 4 "; J;
    FOR I = 1 TO 18
        LOCATE 5 + I, 6
        PRINT HT$(I + (J - 1) * 18);
    NEXT I

HIL20:
    CALL PRESSKEY(Taste$)
    CALL SCAN(Taste$, Isc1, Isc2, Isc3)
    SELECT CASE Isc3
      CASE 27
        CALL LOESCHEN(1, 80, 5, 24)
        EXIT SUB
      CASE 1073
        CALL POSITION(J, 4, 1, -1)
        GOTO HIL10
      CASE 1081
        CALL POSITION(J, 4, 1, 1)
        GOTO HIL10
      CASE ELSE
        GOTO HIL20
      END SELECT

END SUB

SUB LINIE (X, Y)
SHARED IPlotOn
      LINE -(X, Y)
      IF IPlotOn = 1 THEN CALL PLOTTER(1, X, Y)
END SUB

SUB OPTIMIZE
SHARED Nx, Ny, Nx1, Ny1, Nxx, Nyy, Dx(), Dy()
SHARED Xmn, Ymn, Xmx, Ymx, DXplus, DYplus
SHARED Upro$
      Upro$ = "OPTIMIZE"
      DXs = 0
      DYs = 0
      FOR I = 1 TO Nx - 1
          DXs = DXs + Dx(I)
          IF DXs > Xmn AND DXs - Dx(I) <= Xmn THEN
             Nx1 = I
             DXplus = DXs - Xmn - Dx(I)
          END IF
          IF DXs >= Xmx AND DXs - Dx(I) < Xmx THEN Nxx = I + 1
      NEXT I
      FOR J = 1 TO Ny - 1
          DYs = DYs + Dy(J)
          IF DYs > Ymn AND DYs - Dy(J) <= Ymn THEN
             Ny1 = J
             DYplus = DYs - Ymn - Dy(J)
          END IF
          IF DYs >= Ymx AND DYs - Dy(J) < Ymx THEN Nyy = J + 1
      NEXT J
END SUB

SUB PLOTINI
SHARED Xmns, Ymns, Xmxs, Ymxs, P1X, P1Y, P2X, P2Y
SHARED VHP, D90, D0, PU$, PD$, FORM$
SHARED PltFil$, IPlot, IPlotOn
SHARED Upro$

      Upro$ = "PLOTINI"
      EXT$ = ".HPG"
      PROTFIL$ = PltFil$ + MID$(STR$(IPlot), 2) + EXT$
      OPEN PROTFIL$ FOR OUTPUT AS #2
      PRINT #2, " " + CHR$(27) + ".(;"
      PRINT #2, " IN;SP1;"
      PRINT #2, " PS0;"
      PRINT #2, " VS 38.10;"
      DifPx = P2X - P1X
      DifPy = P2Y - P1Y
      DifUx = ABS(Xmxs - Xmns)
      DifUy = ABS(Ymxs - Ymns)
      VHX = DifPx / DifUx
      VHY = DifPy / DifUy
      VHP = VHX
      D90 = 0
      D0 = 1
      IF VHY < VHX THEN
         VHX = DifPx / DifUy
         VHY = DifPy / DifUx
         VHP = VHX
         IF VHY < VHX THEN VHP = VHY
         D90 = 1
         D0 = 0
      END IF
      PU$ = "PU"
      PD$ = "PD"
      FORM$ = " &#####&#####"
      IPlotOn = 1

END SUB

SUB PLOTTER (ISTAT, X, Y)
SHARED VHP, FAK, D90, D0, PU$, PD$, FORM$
SHARED Xmns, Ymns, Xmxs, P1X, P1Y
SHARED Upro$

      Upro$ = "PLOTTER"
      IF ISTAT = 0 THEN P$ = PU$
      IF ISTAT = 1 THEN P$ = PD$
      XK = X - Xmns
      YK = Y - Ymns
      YS = Xmxs - X
      IXX = INT((XK * D0 + YK * D90) * VHP + P1X)
      IYY = INT((YK * D0 + YS * D90) * VHP + P1Y)
      PRINT #2, USING FORM$; P$; IXX; ","; IYY

END SUB

SUB PLOTTEROFF
SHARED IPlot, IPlotOn
SHARED Upro$

     Upro$ = "PLOTTEROFF"
     IPlot = IPlot + 1
     PRINT #2, " SP0;PU 0,0"
     CLOSE #2

END SUB

SUB PLTTXT (Text$, XKOR, YKOR, TXTHIGH)
SHARED IAsci(), IAnf(), ILE(), Ilf(), IVec(), IKey(), IFont
SHARED TXTTANS, TXTTANC, TXTSPAC
SHARED Upro$

      Upro$ = "PLTTXT"
      IXX = 0
      IYY = 0
      FOR IK = 1 TO LEN(Text$)
          FCHAR$ = MID$(Text$, IK, 1)
          J = IKey(ASC(FCHAR$))
          FOR I = 1 TO ILE(J)
              CALL TXTVECTOR(I, J, X, Y, ISTAT, IXX, IYY, TXTHIGH)
              XX = XKOR + X
              YY = YKOR + Y
              IF ISTAT = 0 THEN CALL PUNKT(XX, YY)
              IF ISTAT = 1 THEN CALL LINIE(XX, YY)
         NEXT I
         IXX = IXX + TXTSPAC * Ilf(J) * TXTTANC
         IYY = IYY + TXTTANS * Ilf(J) * TXTSPAC
       NEXT IK

END SUB

SUB PUNKT (X, Y)
SHARED IPlotOn
      PSET (X, Y)
      IF IPlotOn = 1 THEN CALL PLOTTER(0, X, Y)
END SUB

SUB RASTER
SHARED Xmn, Ymn, Xmx, Ymx, Dx(), Dy(), IPlotOn, ILabel
SHARED Nx1, Ny1, Nxx, Nyy, R$
SHARED Upro$
     Upro$ = "RASTER"
     XBE = Xmx - Xmn
     YBE = Ymx - Ymn
     STRL = XBE / 50!
     IF YBE > XBE THEN STRL = YBE / 100!
     IF RIGHT$(R$, 1) = "N" THEN RAS10
     IF IPlotOn = 1 THEN PRINT #2, " SP2;"
     XSU = 0
     FOR I = 1 TO Nxx
         XSU = XSU + Dx(I)
         IF XSU > Xmn AND XSU < Xmx THEN
            YST = Ymn
            DO
            CALL PUNKT(XSU, YST)
            CALL LINIE(XSU, YST + STRL / 2!)
            YST = YST + STRL * 1.5
            LOOP UNTIL YST >= Ymx
         END IF
     NEXT I
     YSU = 0
     FOR J = 1 TO Nyy
         YSU = YSU + Dy(J)
         IF YSU > Ymn AND YSU < Ymx THEN
            XST = Xmn
            DO
            CALL PUNKT(XST, YSU)
            CALL LINIE(XST + STRL / 2!, YSU)
            XST = XST + STRL * 1.5
            LOOP UNTIL XST >= Xmx
         END IF
     NEXT J
     IF IPlotOn = 1 THEN PRINT #2, " SP1;"


RAS10:

     IF ILabel = 0 THEN CALL RECHTECK(Xmn, Ymn, Xmx, Ymx)

END SUB

SUB READFONT
SHARED IAsci(), IAnf(), ILE(), Ilf(), IVec(), IFont
SHARED IRow, IPSet, Iff, ILin
SHARED Upro$
LOCAL A$, J, I, IVecSum

      Upro$ = "READFONT"
      OPEN "ISO.FNT" FOR BINARY AS #11
      GET$ 11, 2, A$
      IFont = CVI(A$)
      IRow = 128
      IPSet = 16
      Iff = 50
      ILin = 32
      GET$ 11, IFONT * 2 * 4, A$
      J = 1
      FOR I = 1 TO IFont
          IAnf(I) = CVI(MID$(A$, J, 2))
          J = J + 2
          ILE(I) = CVI(MID$(A$, J, 2))
          J = J + 2
          Ilf(I) = CVI(MID$(A$, J, 2))
          J = J + 2
          IAsci(I) = CVI(MID$(A$, J, 2))
          J = J + 2
      NEXT I
      GET$ 11, 2, A$
      IVecSum = CVI(A$)
      GET$ 11, IVecSum * 2, A$
      J = 1
      FOR I = 1 TO IVecSum
          IVec(I) = CVI(MID$(A$, J, 2))
          J = J + 2
      NEXT I
      CLOSE 11

END SUB

SUB READNONZERO (XWert)
SHARED Upro$

      Upro$ = "READNONZERO"
      DO
      INPUT #1, XWert
      LOOP UNTIL XWert <> 0

END SUB

SUB RECHTECK (X1, Y1, X2, Y2)
SHARED IPlotOn

      LINE (X1, Y1)-(X2, Y2), , B
      IF IPlotOn = 1 THEN
           CALL PLOTTER(0, X1, Y1)
           CALL PLOTTER(1, X1, Y2)
           CALL PLOTTER(1, X2, Y2)
           CALL PLOTTER(1, X2, Y1)
           CALL PLOTTER(1, X1, Y1)
      END IF

END SUB

SUB RRSET (ISET)
SHARED ZMin, ZMax, Zc, Nx1, Ny1, Nxx, Nyy, NPau, NSatz
SHARED R$, C$(), PltFil$, Proto$
SHARED Xmn, Ymn, Xmx, Ymx, NXTick, NYTick, NsXTick, NsYTick
SHARED HeadTxt$, FootTxt$
SHARED Upro$
      Upro$ = "RRSET"
      IF ISET = 1 THEN RRS10
      Nx1 = INT(VAL(C$(1)))
      Nxx = INT(VAL(C$(2)))
      Ny1 = INT(VAL(C$(3)))
      Nyy = INT(VAL(C$(4)))
      R$ = C$(5)
      Proto$ = C$(6)
      ZMin = VAL(C$(7))
      ZMax = VAL(C$(8))
      Zc = VAL(C$(9))
      NSatz = INT(VAL(C$(10)))
      NPau = INT(VAL(C$(11)))
      PltFil$ = C$(12)
      IF ISET = 0 THEN RRS20

RRS10:
      Xmn = VAL(C$(13))
      Xmx = VAL(C$(14))
      Ymn = VAL(C$(15))
      Ymx = VAL(C$(16))
      HeadTxt$ = C$(17)
      FootTxt$ = C$(18)
      NXTick = INT(VAL(C$(19)))
      NsXTick = INT(VAL(C$(20)))
      NYTick = INT(VAL(C$(21)))
      NsYTick = INT(VAL(C$(22)))

RRS20:

END SUB

SUB SCALA
SHARED X1H, Y1H, X2H, Y2H, X1S, Y1S, X2S, Y2S, ADB, BDA, Xsp, Ysp
SHARED Xmn, Ymn, Xmx, Ymx, Xmns, Ymns, Xmxs, Ymxs, ILabel, Iup, Iop
SHARED Upro$

     Upro$ = "SCALA"

     IF ILabel = 1 THEN
        Xsp = Xmx - Xmn
        Ysp = Ymx - Ymn
        Xmns = Xmn
        Xmxs = Xmx + Xsp / Iup
        Ymns = Ymn - Ysp / Iup
        Ymxs = Ymx + Ysp / Iop
        GOTO SCA10
     END IF
     Xmns = Xmn
     Xmxs = Xmx
     Ymns = Ymn
     Ymxs = Ymx
     X1S = X1H
     Y1S = Y1H
     XD = ABS(Xmx - Xmn)
     YD = ABS(Ymx - Ymn)
     FS = XD / YD
     FH = (X2H - X1H) / (ADB * (Y2H - Y1H))
     IF FS <= FH THEN
        Y2S = Y2H
        X2S = (X1H + (Y2H - Y1H) * XD / YD) * ADB
     END IF
     IF FS > FH THEN
        X2S = X2H
        Y2S = (Y1H + (X2H - X1H) * YD / XD) * BDA
     END IF

SCA10:

END SUB

SUB SET (ISET)
SHARED Zmn, Zmx, Zc, Nx1, Ny1, Nxx, Nyy, NPau, NSatz
SHARED Xmn, Ymn, Xmx, Ymx, NXTick, NYTick, NsXTick, NsYTick, IPlen(), Typ$()
SHARED R$, C$(), PltFil$, Proto$, HeadTxt$, FootTxt$
SHARED Upro$
      Upro$ = "SET"
      IF ISET = 1 THEN SET10
      C$(1) = STR$(Nx1)
      C$(2) = STR$(Nxx)
      C$(3) = STR$(Ny1)
      C$(4) = STR$(Nyy)
      C$(5) = R$
      C$(6) = Proto$
      CALL AXLABEL(Zmn, C$(7), 5, 4)
      CALL AXLABEL(Zmx, C$(8), 5, 4)
      CALL AXLABEL(Zc, C$(9), 5, 4)
      CALL LINKS(C$(7))
      CALL LINKS(C$(8))
      CALL LINKS(C$(9))
      C$(10) = STR$(NSatz)
      C$(11) = STR$(NPau)
      C$(12) = PltFil$
      IF ISET = 0 THEN SET20

SET10:

      CALL AXLABEL(Xmn, C$(13), 5, 4)
      CALL AXLABEL(Xmx, C$(14), 5, 4)
      CALL AXLABEL(Ymn, C$(15), 5, 4)
      CALL AXLABEL(Ymx, C$(16), 5, 4)
      CALL LINKS(C$(13))
      CALL LINKS(C$(14))
      CALL LINKS(C$(15))
      CALL LINKS(C$(16))
      C$(17) = HeadTxt$
      C$(18) = FootTxt$
      C$(19) = STR$(NXTick)
      C$(20) = STR$(NsXTick)
      C$(21) = STR$(NYTick)
      C$(22) = STR$(NsYTick)

SET20:
      FOR I = 1 TO 22
          CALL MAXLEN(C$(I), IPlen(I))
          IF Typ$(I) = "N" THEN CALL RECHTS(C$(I), IPlen(I))
      NEXT I

END SUB

SUB SETCFGPOS
SHARED Typ$(), Pmod$(), Ins$()
SHARED IPlen(), ISP(), IFT(), IZE(), IRow(), ICol()
LOCAL I, IZEIL


      Ins$(0) = " berschreiben "
      Ins$(1) = STRING$(5, 196) + " Einfgen "
      Pmod$(1) = CHR$(24) + " Scanmodus "
      Pmod$(0) = CHR$(25) + " Plotmodus "
      IFT(0) = 12
      IFT(1) = 10
      FOR I = 1 TO 22
         IPlen(I) = 6
         Typ$(I) = "N"
      NEXT I
      FOR I = 1 TO 22
          READ IRow(I)
      NEXT I
      FOR I = 1 TO 22
          READ ICol(I)
      NEXT I
      Typ$(12) = "C"
      Typ$(17) = "C"
      Typ$(18) = "C"
      IPlen(17) = 53
      IPlen(18) = 53
      ISP(1) = 3
      ISP(2) = 40
      IZEIL = 7
      FOR I = 1 TO 6
         IZE(I) = IZEIL
         IZEIL = IZEIL + 2
      NEXT I

END SUB

SUB SETHELPTEXT
SHARED Upro$, HT$()

HT$(1) = " Das Programm ISO entstand in Folge eines hervorragenden  Kurses zur"
HT$(2) = " Grundwassermodellierung  an  der  Technischen  Akademie  Esslingen,"
HT$(3) = " gehalten von Herrn Dr.habil. W. KINZELBACH und Herrn Dr. R. RAUSCH."
HT$(4) = " Es lehnt sich an deren Programm  GWFISO an, bietet  darber  hinaus"
HT$(5) = " jedoch die Mglichkeit, ein nichtquidistantes Gitter zu verwenden,"
HT$(6) = " erstellte Isoliniendarstellungen  ausschnittsweise zu zoomen  sowie"
HT$(7) = " ber Kursor - Tasten nherungsweise  den Z - Wert jedes  beliebigen"
HT$(8) = " Punktes zu bestimmen. Ferner knnen die Zeichnungen  auf HP-GL kom-"
HT$(9) = " patiblen Plottern ausgegeben werden. Sicherlich hat dieses Programm"
HT$(10) = " noch einige  Mngel. Deshalb  wrde ich mich freuen, wenn Sie  mich"
HT$(11) = " ber diese in Kenntnis setzen wrden:"
HT$(12) = ""
HT$(13) = "                             Dipl.-Geol. Dirk Brehm"
HT$(14) = "                   Institut fr Angewandte Geowissenschaften"
HT$(15) = "                     der JUSTUS-LIEBIG-UNIVERSITT GIESSEN"
HT$(16) = "                                Diezstrae 15"
HT$(17) = "                                6300 GIESSEN"
HT$(18) = "                                                         Januar 1988"
HT$(19) = " ISO bentigt folgende Datenstruktur:"
HT$(20) = ""
HT$(21) = " NX   NY                            Anzahl der Knoten "
HT$(22) = " DX(1), DX(2),,, DX(NX-1)           Abstnde der Knoten in X-Richtung"
HT$(23) = " DY(1), DY(2),,, DY(NY-1)           Abstnde der Knoten in Y-Richtung"
HT$(24) = " T(1)                               Zeit in Sekunden - Zeitschritt 1 "
HT$(25) = " Z(1, 1,1), Z(2, 1,1),,, Z(NX, 1,1)"
HT$(26) = " Z(1, 2,1), Z(2, 2,1),,, Z(NX, 2,1)     Z - Werte des ersten"
HT$(27) = "     .         .            .                Datensatzes "
HT$(28) = " Z(1,NY,1), Z(2,NY,1),,, Z(NX,NY,1)"
HT$(29) = " T(2)                               Zeit in Sekunden  - Zeitschritt 2 "
HT$(30) = " Z(1, 1,2), Z(2, 1,2),,, Z(NX, 1,2)"
HT$(31) = " Z(1, 2,2), Z(2, 2,2),,, Z(NX, 2,2)     Z - Werte des zweiten"
HT$(32) = "     .         .                              Datensatzes "
HT$(33) = " Z(1,NY,2), Z(2,NY,2),,, Z(NX,NY,2)"
HT$(34) = " usw."
HT$(35) = ""
HT$(36) = " ISO liest bis zu 16.000 Z - Werte oder maximal 100 Datenstze ein."
HT$(37) = " Das Hauptmenu:"
HT$(38) = ""
HT$(39) = " Daten lesen:   Nach der Eingabe von <CR> erscheint in der rechten"
HT$(40) = "                Bildschirmhlfte eine Auflistung der Dateien des  "
HT$(41) = "                aktuellen Directories. Die gewnschte Datei wird"
HT$(42) = "                mit den Kursortasten in das hell hinterlegte Feld"
HT$(43) = "                gefahren und mit <CR> angewhlt. ISO liest daraufhin"
HT$(44) = "                bis zu 16.000 Z - Werte oder maximal 100 Datenstze"
HT$(45) = "                ein."
HT$(46) = ""
HT$(47) = " Plotparameter: Nach Eingabe von <CR> meldet sich eine Maske in der"
HT$(48) = "                diverse Plotparameter verstellt werden knnen. Die"
HT$(49) = "                linken beiden Felder 'Raster' und 'Plotterprotokoll'"
HT$(50) = "                knnen durch beliebige Tasten verstellt werden."
HT$(51) = "                Die brigen Felder gestatten nur numerische bzw."
HT$(52) = "                alfanumerische Eingaben. Solange das 'Plotterprotokoll'"
HT$(53) = "                eingeschaltet ist, werden allen Bilder auf dem 'Proto-"
HT$(54) = "                koll-File' + Plotnr. + Extension '.HPG' aufgezeichnet."
HT$(55) = "                Nach jeder Vernderung der Plotparameter wird ein"
HT$(56) = "                Plausibilittstest durchgefhrt. Die Maske kann an"
HT$(57) = "                jeder beliebigen Stelle mit <ESC> verlassen werden."
HT$(58) = "                Durch Drcken der Funktionstaste 1 werden die Parameter"
HT$(59) = "                mit den voreingestellten Werten besetzt."
HT$(60) = ""
HT$(61) = "Isolinien:      Die Eingabe von <CR> aktiviert die Konturierung mit"
HT$(62) = "                den gewhlten Plotparametern. Der Bildaufbau kann"
HT$(63) = "                jederzeit durch <ESC> abgebrochen oder zum Zoomen"
HT$(64) = "                durch <F2> unterbrochen werden. Im letzteren Fall"
HT$(65) = "                fragt ISO nach 2 gegenberliegenden Eckpunkten, die"
HT$(66) = "                durch <HOME> besttigt werden. Wurden mehrere"
HT$(67) = "                Datenstze eingelesen, wartet ISO eine mit dem Plot-"
HT$(68) = "                parameter 'Pause' festgelegte Zeit und beginnt dann"
HT$(69) = "                mit dem nchsten Datensatz."
HT$(70) = ""
HT$(71) = " Ende:          Eingabe von <CR> oder <ESC> an jeder beliebigen"
HT$(72) = "                Stelle beendet das Programm.       Viel Erfolg!"

END SUB

SUB SETKEY
SHARED IAsci(), IKey(), IFont
SHARED Upro$

      Upro$ = "SETKEY"
      FOR I = 0 TO 255
          IKey(I) = 32
      NEXT I
      FOR J = 1 TO IFont
          IKey(IAsci(J)) = J
      NEXT J

END SUB

SUB TEXTATT (HBVERH, WINKEL, TNEIGUNG, ZEICHENABSTAND)
SHARED TXTHWRA, TXTCANS, TXTCANC, TXTTANS, TXTTANC, TXTSPAC, PiD180
SHARED Xmn, Ymn, Xmx, Ymx, X1C, Y1C, X2C, Y2C, XV, YV
SHARED Upro$

      Upro$ = "TEXTATT"
      TXTHWRA = HBVERH
      TXTTANS = SIN(WINKEL * PiD180)
      TXTTANC = COS(WINKEL * PiD180)
      TXTCANS = SIN(TNEIGUNG * PiD180)
      TXTCANC = COS(TNEIGUNG * PiD180)
      TXTSPAC = ZEICHENABSTAND
      XV = (Xmx - Xmn) / (X2C - X1C)
      YV = (Ymx - Ymn) / (Y2C - Y1C)

END SUB

SUB TXTVECTOR (I, J, X, Y, IST, IXX, IYY, TH)
SHARED IAnf(), IVec(), Ilf()
SHARED IRow, IPSet, Iff, ILin
SHARED TXTHWRA, TXTCANS, TXTCANC, TXTTANS, TXTTANC
SHARED XV, YV
SHARED Upro$

      Upro$ = "TXTVECTOR"
      IKO = IVec(IAnf(J) + I - 1)
      IST = 0
      IF IKO > 10000 THEN IST = 1
      IXY = IKO - IST * 10000

      IF IST = 0 THEN
         IXY = IXY + IPSet
         IX = IXY \ IRow
         IY = IXY - IX * IRow
         IF IX > 64 THEN IX = 64 - IX
         IF IY > 64 THEN IY = 96 - IY
         GOTO TXV10
      END IF

      IF IST = 1 THEN
         IXY = IXY + ILin - Iff * IRow
         IX = INT(IXY / IRow)
         IY = IXY - IX * IRow
         IF IY > 64 THEN IY = 96 - IY
         IF IX > 64 THEN IX = 64 - IX
      END IF

TXV10:

      IX = IX - 32
      IY = IY - 16
      YH = (IY * TXTHWRA) * TXTCANC
      XN = YH * TXTCANS + IX
      XP = XN * TXTTANC - YH * TXTTANS
      X = (IXX + XP) * TH * XV
      Yp = YH * TXTTANC + XN * TXTTANS
      Y = (IYY + Yp) * TH * YV

END SUB

SUB ZOOM
SHARED XMin, XMax, YMin, YMax, Xmn, Xmx, Ymn, Ymx, X2S, Y2S, NSatz, ILabel
SHARED Upro$
LOCAL Creuz
      DIM Creuz(5000)
      Upro$ = "ZOOM"
      FORM1$ = " X = #####.####   Y = #####.####   Z = #####.###"
      FORM2$ = "   DX = ####.####"
      P1 = 0
      XD = ABS(Xmx - Xmn)
      YD = ABS(Ymx - Ymn)
      TIK = (XD + YD) / 160!
      XM = Xmx - 2 * TIK
      YM = Ymx - 2 * TIK
      Xl = XM - TIK
      Xr = XM + TIK
      YU = YM - TIK
      YO = YM + TIK
      LINE (Xl, YU)-(Xr, YO), 0, BF
      LINE (Xl, YM)-(Xr, YM)
      LINE (XM, YU)-(XM, YO)
      GET (Xl, YU)-(Xr, YO), CREUZ
      Dx = XD / 20!
      X = Xmx - 2 * TIK
      Y = Ymx - 2 * TIK
      PUT (X - TIK, Y + TIK), CREUZ
      X = Xmn + XD / 2!
      Y = Ymn + YD / 2!
      PUT (X - TIK, Y + TIK), CREUZ
      IF ILabel = 0 THEN
         LOCATE 24, 1: PRINT " HOME oder POS1 plaziert  -  ";
         PRINT "PGUP und PGDN  verstellen DX";
      END IF
ZOM10:

      Taste$ = INKEY$
      IF Taste$ = "" THEN ZOM10
      IF ILabel = 0 THEN
         LOCATE 24, 1: PRINT STRING$(80, 32);
         LOCATE 24, 2: PRINT "Fahren Sie bitte auf die linke untere Ecke ...  ";
      END IF
      CALL SCAN(Taste$, Isc1, Isc2, Isc3)
      GOTO ZOM30
ZOM20:
      DO UNTIL INSTAT
      LOOP
      Taste$ = INKEY$
      CALL SCAN(Taste$, Isc1, Isc2, Isc3)
      PUT (X - TIK, Y + TIK), CREUZ
ZOM30:
      IF Isc1 = 27 AND P1 = 0 THEN ZOM60

      SELECT CASE Isc3
        CASE 27
          IF P1 = 0 THEN ZOM60
        CASE 1077
           X = X + Dx
        CASE 1075
           X = X - Dx
        CASE 1072
           Y = Y + Dx
        CASE 1080
           Y = Y - Dx
        CASE 1073
           Dx = Dx * 2
        CASE 1081
           Dx = Dx / 2
        CASE 1071
           P1 = P1 + 1
        CASE ELSE
           GOTO ZOM20
      END SELECT

ZOM40:

      IF X > Xmx - TIK THEN X = Xmx - TIK
      IF X < Xmn + TIK THEN X = Xmn + TIK
      IF Y > Ymx - TIK THEN Y = Ymx - TIK
      IF Y < Ymn + TIK THEN Y = Ymn + TIK
ZOM50:

      IF Dx > XD / 2! THEN Dx = XD / 2!
      IF Dx < (Xmx - Xmn) / 10000! THEN Dx = (Xmx - Xmn) / 10000!
      IF P1 = 1 AND Isc2 = 71 THEN
         LINE (X, Y)-(Xmx, Y)
         LINE (X, Y)-(X, Ymx)
         Xmn = X
         Ymn = Y
         IF ILabel = 0 THEN
            LOCATE 24, 2
            PRINT "Fahren Sie bitte auf die rechte obere Ecke ...  ";
         END IF
      END IF
      PUT (X - TIK, Y + TIK), CREUZ
      IF ILabel = 0 THEN
         CALL ZWERT(X, Y, ZWERT)
         LOCATE 23, 1
         PRINT USING FORM1$; X; Y; ZWERT;
         PRINT USING FORM2$; Dx;
      END IF
      IF P1 < 2 THEN ZOM20
      Xmx = X
      Ymx = Y
ZOM60:
      CLS

END SUB

SUB ZTRUNC
SHARED ZMin, ZMax, Zmn, Zmx, ZMin0, ZMax0, UZ()
SHARED Zc, Icm, Icp, Nx, Ny, Nx1, Ny1, Nxx, Nyy, NSatz
SHARED Upro$
     Upro$ = "ZTRUNC"
     Icm = 0
     Icp = 0
     ZTMN = ZMax0
     ZTMX = ZMin0
     FOR J = Ny1 TO Nyy
         FOR I = Nx1 TO Nxx
             IJ = J * Nx + (NSatz - 1) * Nx * Ny
             K = I + 1 + IJ
             IF UZ(K) > ZTMX THEN ZTMX = UZ(K)
             IF UZ(K) < ZTMN THEN ZTMN = UZ(K)
         NEXT I
     NEXT J
     IF ZTMN >= Zmn THEN Icp = INT((ZTMN - Zmn) / Zc)
     IF ZTMX <= Zmx THEN Icm = INT((ZTMX - Zmx) / Zc)

END SUB

SUB ZWERT (X, Y, ZWERT)
SHARED UZ(), Dx(), Dy(), Nx, Ny, NSatz

     X2 = 0
     Y2 = 0

     FOR I = 1 TO Nx - 1
         X2 = X2 + Dx(I)
         IF X2 > X THEN ZWE10
     NEXT I

ZWE10:
     X1 = X2 - Dx(I)
     FOR J = 1 TO Ny - 1
         Y2 = Y2 + Dy(J)
         IF Y2 > Y THEN ZWE20
     NEXT J

ZWE20:

     Y1 = Y2 - Dy(J)
     IJ = (J - 1) * Nx + (NSatz - 1) * Nx * Ny
     Z1 = UZ(I + IJ)
     Z2 = UZ(I + 1 + IJ)
     Z3 = UZ(I + IJ + Nx)
     Z4 = UZ(I + 1 + IJ + Nx)
     DXDY = Dx(I) * Dy(J)
     ZWE1 = (X - X2) * (Y - Y2) * Z1 / DXDY
     ZWE2 = (X - X1) * (Y - Y2) * Z2 / DXDY
     ZWE3 = (X - X2) * (Y - Y1) * Z3 / DXDY
     ZWE4 = (X - X1) * (Y - Y1) * Z4 / DXDY
     ZWERT = ZWE1 - ZWE2 - ZWE3 + ZWE4

END SUB

